<?php

/** abcOK options */
class abcOKOptions {

	function getOptions() {
		$options = get_option('abcOK_options');
		if (!is_array($options)) {
			$options['description'] = '';
			$options['keywords'] = '';
			$options['author'] = true;
			$options['categories'] = true;
			$options['tags'] = true;
			$options['date'] = true;
			$options['twitter'] = '';
			update_option('abcOK_options', $options);
		}
		return $options;
	}

	function add() {
		if(isset($_POST['abcOK_save'])) {
			$options = abcOKOptions::getOptions();

			// meta
			$options['description'] = stripslashes($_POST['description']);
			$options['keywords'] = stripslashes($_POST['keywords']);

			// author & categories & tags
			if (isset($_POST['author'])){
				if ($_POST['author']) {
					$options['author'] = (bool)true;
				} else {
					$options['author'] = (bool)false;
				}
			}
			else
				$options['author'] = (bool)false;
				
			if (isset($_POST['categories'])){
				if ($_POST['categories']) {
					$options['categories'] = (bool)true;
				} else {
					$options['categories'] = (bool)false;
				}
			}
			else
				$options['categories'] = (bool)false;
				
			if (isset($_POST['tags'])){
				if (!$_POST['tags']) {
					$options['tags'] = (bool)false;
				} else {
					$options['tags'] = (bool)true;
				}
			}
			else
				$options['tags'] = (bool)false;
				
			if (isset($_POST['date'])){
				if (!$_POST['date']) {
					$options['date'] = (bool)false;
				} else {
					$options['date'] = (bool)true;
				}
			}
			else
				$options['date'] = (bool)false;

			// twitter
			$options['twitter'] = stripslashes($_POST['twitter']);

			update_option('abcOK_options', $options);

		} else {
			abcOKOptions::getOptions();
		}

		add_theme_page(__('Theme Options', "abcOK"), __('Theme Options', "abcOK"), 'edit_themes', basename(__FILE__), array('abcOKOptions', 'display'));
	}

	function display() {
		$options = abcOKOptions::getOptions();		
		if (isset($_REQUEST['abcOK_save'])) {
			if ( $_REQUEST['abcOK_save'] ) echo '<div id="message" class="updated fade"><p><strong>'.__('abcOK Theme: Settings saved.',"abcOK").'</strong></p></div>';	
		}
?>
<style>
	.wrap { border:#ccc 1px dashed;padding:10px;}
	.themeinfo { margin:1em;padding:1em;line-height:1.6em;}
	h4 {font-size:1.3em;color:#265e15;font-weight:normal;margin:0;padding:10px 0;}
</style>



<form action="#" method="post" enctype="multipart/form-data" name="abcOK_form" id="abcOK_form">
	<div class="wrap">
		<h2><?php _e('abcOK 1.01 Options', "abcOK"); ?></h2>
		<div class="themeinfo">
			<h4><?php _e('Theme Page:',"abcOK");?> <a href="http://www.sql-statements.com/themes/">abcOK</a> </h4>
			<h4><?php _e('Designed & Coded by:',"abcOK");?> <a href="http://www.sql-statements.com/" title="SQL Statements Tutorial"  target="_blank">sqls</a></h4>
		</div>

		<table class="form-table">
			<tbody>
				<tr valign="top">
					<th scope="row" style="width:10%;"><?php _e('Meta', "abcOK"); ?></th>
					<td>
						<?php _e('Description:', "abcOK"); ?>
						<br/>
						<input type="text" name="description" id="description" class="code" style="width:98%;" value="<?php echo($options['description']); ?>">
						<br/>
						<?php _e('Keywords:', "abcOK"); ?> <small><?php _e('( Separate keywords with commas )', "abcOK"); ?></small>
						<br/>
						<input type="text" name="keywords" id="keywords" class="code" style="width:98%;" value="<?php echo($options['keywords']); ?>">
					</td>
				</tr>
			</tbody>
		</table>
		<table class="form-table">
			<tbody>
				<tr valign="top">
					<th scope="row" style="width:10%;"><?php _e('Posts'); ?></th>
					<td>
						<label style="margin-right:20px;">
							<input name="author" type="checkbox" value="checkbox" <?php if($options['author']) echo "checked='checked'"; ?> />
							 <?php _e('Show author on posts.', "abcOK"); ?>
						</label>
						<label style="margin-right:20px;">
							<input name="categories" type="checkbox" value="checkbox" <?php if($options['categories']) echo "checked='checked'"; ?> />
							 <?php _e('Show categories on posts.', "abcOK"); ?>
						</label>
						<label>
							<input name="tags" type="checkbox" value="checkbox" <?php if($options['tags']) echo "checked='checked'"; ?> />
							 <?php _e('Show tags on posts.', "abcOK"); ?>
						</label>
						<label>
							<input name="date" type="checkbox" value="checkbox" <?php if($options['date']) echo "checked='checked'"; ?> />
							 <?php _e('Show date on posts.', "abcOK"); ?>
						</label>
					</td>
				</tr>
			</tbody>
		</table>
		<table class="form-table">
			<tbody>
				<tr valign="top">
					<th scope="row" style="width:10%;"><?php _e('Twitter'); ?></th>
					<td>
						<input type="text" name="twitter" id="twitter" class="code" style="width:50%;" value="<?php echo($options['twitter']); ?>">
					</td>
				</tr>
			</tbody>
		</table>

		<p class="submit">
			<input class="button-primary" type="submit" name="abcOK_save" value="<?php _e('Save Changes', "abcOK"); ?>" />			
		</p>
	</div>

</form>

<?php
	}
}

// register functions
add_action('admin_menu', array('abcOKOptions', 'add'));

if ( ! isset( $content_width ) )
	$content_width = 640;

/** Tell WordPress to run theme_setup() when the 'after_setup_theme' hook is run. */
add_action( 'after_setup_theme', 'theme_setup' );

if ( ! function_exists( 'theme_setup' ) ):
/**
 * Sets up theme defaults and registers support for various WordPress features.
 *
 * Note that this function is hooked into the after_setup_theme hook, which runs
 * before the init hook. The init hook is too late for some features, such as indicating
 * support post thumbnails.
 *
 * To override theme_setup() in a child theme, add your own theme_setup to your child theme's
 * functions.php file.
 *
 * @uses add_theme_support() To add support for post thumbnails and automatic feed links.
 * @uses register_nav_menus() To add support for navigation menus.
 * @uses add_custom_background() To add support for a custom background.
 * @uses add_editor_style() To style the visual editor.
 * @uses load_theme_textdomain() For translation/localization support.
 * @uses add_custom_image_header() To add support for a custom header.
 * @uses register_default_headers() To register the default custom header images provided with the theme.
 * @uses set_post_thumbnail_size() To set a custom post thumbnail size.
 *
 */
function theme_setup() {

	// This theme styles the visual editor with editor-style.css to match the theme style.
	add_editor_style();

	// This theme uses post thumbnails
	add_theme_support( 'post-thumbnails' );

	// Add default posts and comments RSS feed links to head
	add_theme_support( 'automatic-feed-links' );

	// Make theme available for translation
	// Translations can be filed in the /languages/ directory
	load_theme_textdomain( "abcOK", TEMPLATEPATH . '/languages' );

	$locale = get_locale();
	$locale_file = TEMPLATEPATH . "/languages/$locale.php";
	if ( is_readable( $locale_file ) )
		require_once( $locale_file );

	// This theme uses wp_nav_menu() in one location.
	register_nav_menus( array(
		'primary' => __( 'Primary Navigation', "abcOK" ),
	) );

	// This theme allows users to set a custom background
	add_custom_background();

	// Default custom headers packaged with the theme. %s is a placeholder for the theme template directory URI.
	register_default_headers( array(
		'berries' => array(
			'url' => '%s/images/headers/berries.jpg',
			'thumbnail_url' => '%s/images/headers/berries-thumbnail.jpg',
			/* translators: header image description */
			'description' => __( 'Berries', "abcOK" )
		),
		'cherryblossom' => array(
			'url' => '%s/images/headers/cherryblossoms.jpg',
			'thumbnail_url' => '%s/images/headers/cherryblossoms-thumbnail.jpg',
			/* translators: header image description */
			'description' => __( 'Cherry Blossoms', "abcOK" )
		),
		'concave' => array(
			'url' => '%s/images/headers/concave.jpg',
			'thumbnail_url' => '%s/images/headers/concave-thumbnail.jpg',
			/* translators: header image description */
			'description' => __( 'Concave', "abcOK" )
		),
		'fern' => array(
			'url' => '%s/images/headers/fern.jpg',
			'thumbnail_url' => '%s/images/headers/fern-thumbnail.jpg',
			/* translators: header image description */
			'description' => __( 'Fern', "abcOK" )
		),
		'forestfloor' => array(
			'url' => '%s/images/headers/forestfloor.jpg',
			'thumbnail_url' => '%s/images/headers/forestfloor-thumbnail.jpg',
			/* translators: header image description */
			'description' => __( 'Forest Floor', "abcOK" )
		),
		'inkwell' => array(
			'url' => '%s/images/headers/inkwell.jpg',
			'thumbnail_url' => '%s/images/headers/inkwell-thumbnail.jpg',
			/* translators: header image description */
			'description' => __( 'Inkwell', "abcOK" )
		),
		'path' => array(
			'url' => '%s/images/headers/path.jpg',
			'thumbnail_url' => '%s/images/headers/path-thumbnail.jpg',
			/* translators: header image description */
			'description' => __( 'Path', "abcOK" )
		),
		'sunset' => array(
			'url' => '%s/images/headers/sunset.jpg',
			'thumbnail_url' => '%s/images/headers/sunset-thumbnail.jpg',
			/* translators: header image description */
			'description' => __( 'Sunset', "abcOK" )
		)
	) );
}
endif;		


// Get the page number
function get_page_number() {
    if (get_query_var('paged')) {
        print ' | ' . __( 'Page ' , "abcOK") . get_query_var('paged');
    }
} // end get_page_number


// For category lists on category archives: Returns other categories except the current one (redundant)
function cats_meow($glue) {
        $current_cat = single_cat_title( '', false );
        $separator = "\n";
        $cats = explode( $separator, get_the_category_list($separator) );
        foreach ( $cats as $i => $str ) {
                if ( strstr( $str, ">$current_cat<" ) ) {
                        unset($cats[$i]);
                        break;
                }
        }
        if ( empty($cats) )
                return false;

        return trim(join( $glue, $cats ));
} // end cats_meow


// For tag lists on tag archives: Returns other tags except the current one (redundant)
function tag_ur_it($glue) {
        $current_tag = single_tag_title( '', '',  false );
        $separator = "\n";
        $tags = explode( $separator, get_the_tag_list( "", "$separator", "" ) );
        foreach ( $tags as $i => $str ) {
                if ( strstr( $str, ">$current_tag<" ) ) {
                        unset($tags[$i]);
                        break;
                }
        }
        if ( empty($tags) )
                return false;

        return trim(join( $glue, $tags ));
} // end tag_ur_it

//Register widgetized areas 
function theme_widgets_init() {
	// Area 1, located at the top of the sidebar.
	register_sidebar( array(
		'name' => __( 'Sidebar', "abcOK" ),
		'id' => 'primary-widget-area',
		'description' => __( '', "abcOK" ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>',
	) );

	// Area 2, located in the footer. Empty by default.
	register_sidebar( array(
		'name' => __( 'First Footer Widget Area', "abcOK" ),
		'id' => 'first-footer-widget-area',
		'description' => __( 'The first footer widget area', "abcOK" ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>',
	) );

	// Area 3, located in the footer. Empty by default.
	register_sidebar( array(
		'name' => __( 'Second Footer Widget Area', "abcOK" ),
		'id' => 'second-footer-widget-area',
		'description' => __( 'The second footer widget area', "abcOK" ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>',
	) );

	// Area 4, located in the footer. Empty by default.
	register_sidebar( array(
		'name' => __( 'Third Footer Widget Area', "abcOK" ),
		'id' => 'third-footer-widget-area',
		'description' => __( 'The third footer widget area', "abcOK" ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>',
	) );

	// Area 5, located in the footer. Empty by default.
	register_sidebar( array(
		'name' => __( 'Fourth Footer Widget Area', "abcOK" ),
		'id' => 'fourth-footer-widget-area',
		'description' => __( 'The fourth footer widget area', "abcOK" ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>',
	) );
}
// Register sidebars by running theme_widgets_init() on the widgets_init hook. 
add_action( 'widgets_init', 'theme_widgets_init' );

function ap_rssLink(){
	$link = get_option('ap_rssUrl');
	return (!empty($link)) ? $link :  get_bloginfo('rss2_url');
}

// Produces an avatar image with the hCard-compliant photo class
function commenter_link() {
        $commenter = get_comment_author_link();
        if ( ereg( '<a[^>]* class=[^>]+>', $commenter ) ) {
                $commenter = ereg_replace( '(<a[^>]* class=[\'"]?)', '\\1url ' , $commenter );
        } else {
                $commenter = ereg_replace( '(<a )/', '\\1class="url "' , $commenter );
        }
        $avatar_email = get_comment_author_email();
        $avatar = str_replace( "class='avatar", "class='photo avatar", get_avatar( $avatar_email, 80 ) );
        echo $avatar . ' <span class="fn n">' . $commenter . '</span>';
} // end commenter_link


if ( ! function_exists( 'theme_comment' ) ) :

function theme_comment( $comment, $args, $depth ) {
	$GLOBALS['comment'] = $comment;
	switch ( $comment->comment_type ) :
		case '' :
	?>
	<li <?php comment_class(); ?> id="li-comment-<?php comment_ID(); ?>">
		<div id="comment-<?php comment_ID(); ?>">
		<div class="comment-author vcard">
			<?php echo get_avatar( $comment, 40 ); ?>
			<?php printf( __( '%s <span class="says">says:</span>', "abcOK" ), sprintf( '<cite class="fn">%s</cite>', get_comment_author_link() ) ); ?>
		</div><!-- .comment-author .vcard -->
		<?php if ( $comment->comment_approved == '0' ) : ?>
			<em><?php _e( 'Your comment is awaiting moderation.', "abcOK" ); ?></em>
			<br />
		<?php endif; ?>

		<div class="comment-meta commentmetadata"><a href="<?php echo esc_url( get_comment_link( $comment->comment_ID ) ); ?>">
			<?php
				/* translators: 1: date, 2: time */
				printf( __( '%1$s at %2$s', "abcOK" ), get_comment_date(),  get_comment_time() ); ?></a><?php edit_comment_link( __( '(Edit)', "abcOK" ), ' ' );
			?>
		</div><!-- .comment-meta .commentmetadata -->

		<div class="comment-body"><?php comment_text(); ?></div>

		<div class="reply">
			<?php comment_reply_link( array_merge( $args, array( 'depth' => $depth, 'max_depth' => $args['max_depth'] ) ) ); ?>
		</div><!-- .reply -->
	</div><!-- #comment-##  -->

	<?php
			break;
		case 'pingback'  :
		case 'trackback' :
	?>
	<li class="post pingback">
		<p><?php _e( 'Pingback:', "abcOK" ); ?> <?php comment_author_link(); ?><?php edit_comment_link( __('(Edit)', "abcOK"), ' ' ); ?></p>
	<?php
			break;
	endswitch;
}
endif;


// Custom callback to list comments in the your-theme style
function custom_comments($comment, $args, $depth) {
  $GLOBALS['comment'] = $comment;
        $GLOBALS['comment_depth'] = $depth;
  ?>
        <li id="comment-<?php comment_ID() ?>" <?php comment_class() ?>>
                <div class="comment-author vcard"><?php commenter_link() ?></div>
                <div class="comment-meta"><?php printf(__('Posted %1$s at %2$s <span class="meta-sep">|</span> <a href="%3$s" title="Permalink to this comment">Permalink</a>', "abcOK"),
                                        get_comment_date(),
                                        get_comment_time(),
                                        '#comment-' . get_comment_ID() );
                                        edit_comment_link(__('Edit', "abcOK"), ' <span class="meta-sep">|</span> <span class="edit-link">', '</span>'); ?></div>
  <?php if ($comment->comment_approved == '0') _e("\t\t\t\t\t<span class='unapproved'>Your comment is awaiting moderation.</span>\n", "abcOK") ?>
          <div class="comment-content">
                <?php comment_text() ?>
                </div>
                <?php // echo the comment reply link
                        if($args['type'] == 'all' || get_comment_type() == 'comment') :
                                comment_reply_link(array_merge($args, array(
                                        'reply_text' => __('Reply',"abcOK"), 
                                        'login_text' => __('Log in to reply.',"abcOK"),
                                        'depth' => $depth,
                                        'before' => '<div class="comment-reply-link">', 
                                        'after' => '</div>'
                                )));
                        endif;
                ?>
<?php } // end custom_comments


// Custom callback to list pings
function custom_pings($comment, $args, $depth) {
       $GLOBALS['comment'] = $comment;
        ?>
                <li id="comment-<?php comment_ID() ?>" <?php comment_class() ?>>
                        <div class="comment-author"><?php printf(__('By %1$s on %2$s at %3$s', "abcOK"),
                                        get_comment_author_link(),
                                        get_comment_date(),
                                        get_comment_time() );
                                        edit_comment_link(__('Edit', "abcOK"), ' <span class="meta-sep">|</span> <span class="edit-link">', '</span>'); ?></div>
    <?php if ($comment->comment_approved == '0') _e('\t\t\t\t\t<span class="unapproved">Your trackback is awaiting moderation.</span>\n', "abcOK") ?>
            <div class="comment-content">
                        <?php comment_text() ?>
                        </div>
<?php } // end custom_pings

